"use strict";

exports.__esModule = true;
exports.createCollection = createCollection;
var _parseFqdn = require("../util/parseFqdn");
var _state = require("../state");
var _core = require("react-query/core");
function createCollection(container, config, {
  paginationModeRef,
  overrides
} = {}) {
  const {
    errorMonitor,
    errorHandler,
    onlineState,
    history,
    translate,
    queryCache,
    showToast,
    initialFetch,
    lodash
  } = container;
  const {
    queryName,
    fqdn
  } = config;

  // fallbacks to queryName for backwards compatibility
  const parsedFqdn = (0, _parseFqdn.parseFqdn)(fqdn || queryName);
  return new _state.CollectionState({
    ...config,
    queryName,
    fqdn: parsedFqdn,
    paginationModeRef,
    queryCache: (overrides == null ? void 0 : overrides.queryCache) ?? (typeof process !== 'undefined' && process.env.STORYBOOK_DOCS === 'true' ? new _core.QueryCache() : queryCache),
    history,
    errorMonitor,
    errorHandler,
    showToast: (overrides == null ? void 0 : overrides.showToast) ?? showToast,
    translate,
    onlineState,
    initDependencies: initialFetch,
    lodash
  });
}
//# sourceMappingURL=createCollection.js.map