"use strict";

exports.__esModule = true;
exports.useCollection = useCollection;
exports.useCreateCollection = useCreateCollection;
exports.usePrivateCreateCollection = usePrivateCreateCollection;
var _react = require("react");
var _providers = require("../../providers");
var _createCollection = require("../createCollection");
var _createCollectionConfig = require("../createCollectionConfig");
function usePrivateCreateCollection() {
  const container = (0, _providers.useWixPatternsContainer)();
  const overrides = (0, _providers.useWixPatternsContainerOverrides)();
  return (0, _react.useCallback)((config, options = {}) => (0, _createCollection.createCollection)(container, (0, _createCollectionConfig.createCollectionConfig)(config), {
    ...options,
    overrides
  }), []);
}
function useCreateCollection() {
  const createCollection = usePrivateCreateCollection();
  return (0, _react.useCallback)(config => createCollection(config), []);
}
function useCollection(config) {
  const createCollection = useCreateCollection();
  const [collection] = (0, _react.useState)(() => createCollection(config));
  return collection;
}
//# sourceMappingURL=useCollection.js.map