"use strict";

exports.__esModule = true;
exports.useCollectionPageState = useCollectionPageState;
var _react = require("react");
var _state = require("../state");
var _mobx = require("mobx");
var _providers = require("../providers");
function useCollectionPageState({
  pageTitle,
  hasHeader,
  hideHeaderTotal,
  ...rest
} = {}, stateOverride) {
  const routerState = (0, _providers.useWixPatternsContainer)();
  const [state] = (0, _react.useState)(() => stateOverride ?? new _state.CollectionPageState({
    pageTitle,
    hasHeader,
    hideHeaderTotal,
    withinRouter: Boolean(routerState),
    ...rest
  }));
  (0, _react.useEffect)(() => {
    (0, _mobx.runInAction)(() => {
      state.pageTitle = pageTitle;
    });
  }, [pageTitle]);
  (0, _react.useEffect)(() => {
    (0, _mobx.runInAction)(() => {
      state.hasHeader = hasHeader;
    });
  }, [hasHeader]);
  return state;
}
//# sourceMappingURL=useCollectionPageState.js.map