"use strict";

exports.__esModule = true;
exports.useCreateExport = useCreateExport;
var _providers = require("../providers");
var _state = require("../state");
var _react = require("react");
function useCreateExport(params) {
  const collection = (0, _providers.useCollectionContext)();
  const collectionPageState = (0, _providers.useCollectionPageContext)();
  const {
    createExportAsyncJobRequest,
    transformPlatformizedQuery,
    differentQueryEndpointThanCollection,
    customTotal,
    reportBi,
    exportModalState,
    saveAs
  } = params;
  const {
    httpClient,
    showToast,
    translate,
    window,
    internalMonitor,
    onlineState,
    errorHandler
  } = (0, _providers.useWixPatternsContainer)();
  return (0, _react.useCallback)(() => {
    return new _state.ExportState({
      transformPlatformizedQuery,
      createExportAsyncJobRequest,
      saveAs,
      httpClient,
      showToast,
      translate,
      collection,
      differentQueryEndpointThanCollection,
      customTotal,
      reportBi,
      exportModalState,
      collectionPageState,
      window,
      onlineState,
      internalMonitor,
      errorHandler
    });
  }, []);
}
//# sourceMappingURL=useExport.js.map