"use strict";

exports.__esModule = true;
exports.useCreateOptimisticActions = useCreateOptimisticActions;
exports.useOptimisticActions = useOptimisticActions;
var _react = require("react");
var _state = require("../state");
var _providers = require("../providers");
function useCreateOptimisticActions() {
  const container = (0, _providers.useWixPatternsContainer)();
  return (0, _react.useCallback)((collection, params) => collection._optimisticActions ?? new _state.CollectionOptimisticActions({
    container,
    collection,
    ...params
  }), []);
}
function useOptimisticActions(collection, params) {
  const createOptimisticActions = useCreateOptimisticActions();
  const [optimisticActions] = (0, _react.useState)(() => createOptimisticActions(collection, params));
  (0, _react.useEffect)(() => optimisticActions.init(), []);
  return optimisticActions;
}
//# sourceMappingURL=useOptimisticActions.js.map