"use strict";

exports.__esModule = true;
exports.useCreatePicker = useCreatePicker;
exports.usePicker = usePicker;
var _react = require("react");
var _useCollection = require("./useCollection");
var _state = require("../state");
var _providers = require("../providers");
function useCreatePicker() {
  const {
    createBILogger
  } = (0, _providers.useWixPatternsContainer)();
  const createCollection = (0, _useCollection.useCreateCollection)();
  return (0, _react.useCallback)(config => {
    const {
      events,
      ...collectionConfig
    } = config;
    const collection = createCollection({
      ...collectionConfig,
      events
    });
    return new _state.PickerState({
      getMaxItems: () => undefined,
      collection,
      events,
      reportBi: createBILogger({
        ...collection.fqdn
      })
    });
  }, []);
}
function usePicker(config) {
  const createPickerStandalone = useCreatePicker();
  const [state] = (0, _react.useState)(() => createPickerStandalone(config));
  return state;
}
//# sourceMappingURL=usePicker.js.map