"use strict";

exports.__esModule = true;
exports.assertContextValue = assertContextValue;
exports.createContext = createContext;
var _react = require("react");
function assertContextValue(contextName, value) {
  if (process.env.NODE_ENV !== 'production' && !value) {
    throw new Error(`${contextName}: value was not provided`);
  }
}
function createContext(contextName) {
  const Context = /*#__PURE__*/(0, _react.createContext)(null);
  const Provider = Context.Provider;
  const Consumer = Context.Consumer;
  const useContext = () => {
    const value = (0, _react.useContext)(Context);
    assertContextValue(contextName, value);
    return value;
  };
  return {
    Context,
    Provider,
    Consumer,
    useContext
  };
}
//# sourceMappingURL=createContext.js.map