"use strict";

exports.__esModule = true;
exports.createDataExtensionSchemaErrors = void 0;
const createDataExtensionSchemaErrors = ({
  translate: t
}) => {
  return {
    applicationError: {
      INVALID_NAMESPACE: () => ({
        message: t('cairo.customFields.createDataExtension.invalid-namespace.error'),
        action: {
          text: t('cairo.error.contactSupport.cta'),
          onClick: () => {}
        }
      }),
      FQDN_NOT_FOUND: () => ({
        message: t('cairo.customFields.createDataExtension.fqdn-not-found.error'),
        action: {
          text: t('cairo.error.contactSupport.cta'),
          onClick: () => {}
        }
      }),
      FQDN_NOT_EXTENSIBLE: () => ({
        message: t('cairo.customFields.createDataExtension.fqdn-not-extensible.error'),
        action: {
          text: '',
          onClick: () => {}
        }
      })
    }
  };
};
exports.createDataExtensionSchemaErrors = createDataExtensionSchemaErrors;
//# sourceMappingURL=createDataExtensionSchemaErrors.js.map