"use strict";

exports.__esModule = true;
exports.createAppSettingsCapsule = void 0;
var _types = require("@wix/bex-utils/@wix/ambassador-app-settings-v1-settings/types");
var _AppSettingsCapsule = require("./AppSettingsCapsule");
var _mapGuidComponentIdToNonGuid = require("./mapGuidComponentIdToNonGuid");
const createAppSettingsCapsule = ({
  httpClient,
  environment,
  queryCache
}) => {
  return options => new _AppSettingsCapsule.AppSettingsCapsule({
    queryCache,
    httpClient,
    context: {
      componentId: (0, _mapGuidComponentIdToNonGuid.mapGuidComponentIdToNonGuid)(environment.componentId || environment.artifactId),
      namespace: options.namespace,
      host: _types.Host.BUSINESS_MANAGER
    }
  });
};
exports.createAppSettingsCapsule = createAppSettingsCapsule;
//# sourceMappingURL=createAppSettingsCapsule.js.map