"use strict";

exports.__esModule = true;
exports.createComponentSettings = void 0;
var _DataCapsuleMergeStrategy = require("./DataCapsuleMergeStrategy");
var _mapGuidComponentIdToNonGuid = require("./mapGuidComponentIdToNonGuid");
const createComponentSettings = ({
  createEssentials,
  environment
}) => {
  return options => {
    const {
      dataCapsule: _dataCapsule
    } = createEssentials({
      dataCapsule: {
        storageStrategy: 'userPreferences',
        namespace: options.namespace,
        scope: (0, _mapGuidComponentIdToNonGuid.mapGuidComponentIdToNonGuid)(environment.componentId || environment.artifactId)
      }
    });
    const componentSettings = _dataCapsule;
    componentSettings.storageStrategy = new _DataCapsuleMergeStrategy.DataCapsuleMergeStrategy({
      storage: componentSettings.storageStrategy
    });
    return _dataCapsule;
  };
};
exports.createComponentSettings = createComponentSettings;
//# sourceMappingURL=createComponentSettings.js.map