"use strict";

exports.__esModule = true;
exports.experimentsFallbackApi = void 0;
exports.getExperimentsCompat = getExperimentsCompat;
exports.getWixPatternsWindowExperiments = getWixPatternsWindowExperiments;
function getWixPatternsWindowExperiments() {
  return window.__CAIRO_EXPERIMENTS__;
}
function getExperimentsCompat(essentials) {
  try {
    return essentials.experiments ?? experimentsFallbackApi();
  } catch (e) {
    console.error(e);
    return experimentsFallbackApi();
  }
}
const experimentsFallbackApi = () => ({
  enabled: () => false,
  ready: () => Promise.resolve(true),
  get: () => ''
});
exports.experimentsFallbackApi = experimentsFallbackApi;
//# sourceMappingURL=experiments.js.map