"use strict";

exports.__esModule = true;
exports.commonExportAsyncJobErrors = void 0;
const commonExportAsyncJobErrors = ({
  translate: t
}) => ({
  UNAUTHENTICATED: () => ({
    message: t('cairo.export.sessionExpiredMessage'),
    action: {
      text: t('Refresh'),
      onClick: () => {
        window.location.reload();
      }
    }
  }),
  PERMISSION_DENIED: () => ({
    message: t('cairo.export.noPermissionsMessage'),
    action: {
      text: t('cairo.export.noPermissionsCTA'),
      onClick: () => {
        window.open('https://support.wix.com/en/article/roles-permissions-overview', '_blank');
      }
    }
  })
});
exports.commonExportAsyncJobErrors = commonExportAsyncJobErrors;
//# sourceMappingURL=commonExportAsyncJobErrors.js.map