"use strict";

exports.__esModule = true;
exports.createExportAsyncJobErrors = void 0;
var _commonExportAsyncJobErrors = require("./commonExportAsyncJobErrors");
const createExportAsyncJobErrors = ({
  translate: t
}) => {
  return {
    applicationError: {
      method_endpoint_not_found: () => ({
        message: t('cairo.export.CreateExportAsyncJob.method-endpoint-not-found.error'),
        action: {
          text: t('cairo.error.contactSupport.cta'),
          onClick: () => {
            window.open('https://www.wix.com/contact', '_blank');
          }
        }
      })
    },
    statusCodeError: {
      ...(0, _commonExportAsyncJobErrors.commonExportAsyncJobErrors)({
        translate: t
      })
    }
  };
};
exports.createExportAsyncJobErrors = createExportAsyncJobErrors;
//# sourceMappingURL=createExportAsyncJobErrors.js.map