"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.PromisesState = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _mobx = require("mobx");
var _PromiseState = require("./PromiseState");
class PromisesState {
  constructor() {
    (0, _defineProperty2.default)(this, "promises", _mobx.observable.array([], {
      deep: false
    }));
    (0, _mobx.makeObservable)(this, {
      push: _mobx.action.bound,
      addPromise: _mobx.action.bound,
      isLoadingPromises: _mobx.computed
    });
  }
  async addPromise(createPromise) {
    return this.push(new _PromiseState.PromiseState({
      createPromise
    }));
  }
  async push(promise) {
    this.promises.push(promise);
    await promise.fetch();
    (0, _mobx.runInAction)(() => {
      this.promises.remove(promise);
    });
  }
  get isLoadingPromises() {
    return this.promises.some(promise => promise.status.isLoading);
  }
}
exports.PromisesState = PromisesState;
//# sourceMappingURL=PromisesState.js.map