"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.QueryResultSimulationDefault = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
function getKey(item, maybeKeyOfT) {
  return item[maybeKeyOfT];
}
class QueryResultSimulationDefault {
  constructor(params) {
    (0, _defineProperty2.default)(this, "collection", void 0);
    (0, _defineProperty2.default)(this, "orderBy", computedQuery => {
      const {
        sort
      } = computedQuery;
      return [...(sort ?? [])];
    });
    (0, _defineProperty2.default)(this, "predicate", computedQuery => {
      const {
        collection
      } = this;
      const {
        query,
        itemName
      } = collection;
      const {
        search,
        filters
      } = computedQuery;
      return item => {
        for (const [filterName, value] of Object.entries(filters)) {
          const filter = query.filters[filterName];
          if (filter == null) {
            return false;
          }
          const fieldValue = getKey(item, filterName);
          if (value != null && fieldValue != null && !filter.matches(fieldValue, value)) {
            return false;
          }
        }
        if (search && !itemName(item).toLowerCase().includes(search)) {
          return false;
        }
        return true;
      };
    });
    this.collection = params.collection;
  }
}
exports.QueryResultSimulationDefault = QueryResultSimulationDefault;
//# sourceMappingURL=QueryResultSimulationDefault.js.map