"use strict";

exports.__esModule = true;
exports.getJobItemsAbsoluteCounter = getJobItemsAbsoluteCounter;
function getJobItemsAbsoluteCounter(job, {
  query,
  totalForExport
}) {
  const paging = query.paging ?? query.cursorPaging;
  const getOffset = () => {
    var _job$data, _job$data2, _job$data3;
    if (((_job$data = job.data) == null ? void 0 : _job$data.processedItemsCount) != null) {
      return job.data.processedItemsCount;
    }
    if (((_job$data2 = job.data) == null || (_job$data2 = _job$data2.pagingMetadata) == null ? void 0 : _job$data2.offset) != null) {
      return Math.max(job.data.pagingMetadata.offset - (paging == null ? void 0 : paging.limit), 0);
    }
    const iterationsCount = ((_job$data3 = job.data) == null ? void 0 : _job$data3.iterationsCount) ?? 0;
    return Math.max(iterationsCount - 1, 0) * (paging == null ? void 0 : paging.limit);
  };
  const processedItemsCount = getOffset();
  return totalForExport ? Math.min(processedItemsCount, totalForExport) : processedItemsCount;
}
//# sourceMappingURL=getJobItemsAbsoluteCounter.js.map