"use strict";

exports.__esModule = true;
exports.filterPageByPatches = void 0;
const filterPageByPatches = (patches, {
  itemKey,
  itemPredicate
}) => item => {
  const itemAfterAllPatches = patches.reduce((acc, {
    selector,
    patch,
    patchedItems,
    actionType
  }) => {
    if (!selector(item)) {
      return acc;
    }
    if (actionType === 'createMany') {
      return {
        ...acc,
        ...patch(item)
      };
    }
    if (actionType === 'deleteMany' || actionType === 'deleteAll') {
      return null;
    }
    const actionIsMatch = (() => {
      switch (actionType) {
        case 'updateMany':
          return patchedItems.get(itemKey(item));
        case 'updateAll':
        case 'updateAllConst':
          return {
            ...acc,
            ...patch(item)
          };
        default:
          return null;
      }
    })();
    return acc ? actionIsMatch : acc;
  }, item);
  return itemAfterAllPatches ? itemPredicate(itemAfterAllPatches) : false;
};
exports.filterPageByPatches = filterPageByPatches;
//# sourceMappingURL=filterPageByPatches.js.map