"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.orderByOrders = orderByOrders;
var _orderBy = _interopRequireDefault(require("lodash/orderBy"));
var _trimAddedItemsFromPagePredicate = require("./trimAddedItemsFromPagePredicate");
function orderByOrders(pageWithPatchedItems, toMerge, {
  limit,
  itemKey,
  orders
}) {
  const pageWithPatchedItemsOrdered = orders.length ? (0, _orderBy.default)(pageWithPatchedItems, orders.map(({
    fieldName
  }) => {
    const fn = typeof fieldName === 'function' ? fieldName : e => e[fieldName];
    return ({
      item,
      orderByItem
    }, index) => {
      const finalItem = orderByItem ?? item;
      return fn(finalItem, index);
    };
  }), orders.map(({
    order
  }) => order)) : pageWithPatchedItems;
  return pageWithPatchedItemsOrdered.map(({
    item
  }) => item).filter((0, _trimAddedItemsFromPagePredicate.trimAddedItemsFromPagePredicate)({
    addedItems: toMerge.all,
    itemKey,
    limit
  }));
}
//# sourceMappingURL=orderByOrders.js.map