"use strict";

exports.__esModule = true;
exports.createUseExperimentsCompat = void 0;
const createUseExperimentsCompat = useExperiments => {
  const fallbackApi = {
    ready: true,
    experiments: {
      enabled: () => false
    }
  };
  return function useExperimentsCompat() {
    try {
      const experiments = useExperiments();
      if (experiments == null) {
        return fallbackApi;
      }
      return experiments;
    } catch (e) {
      console.error(e);
      return fallbackApi;
    }
  };
};
exports.createUseExperimentsCompat = createUseExperimentsCompat;
//# sourceMappingURL=useExperimentsCompat.js.map