"use strict";

exports.__esModule = true;
exports.advance = advance;
exports.flush = flush;
exports.flushPromise = flushPromise;
var _timers = require("timers");
async function flush(iterations = 5) {
  for (let i = 0; i < iterations; i++) {
    await new Promise(resolve => (0, _timers.setImmediate)(resolve));
    jest.runOnlyPendingTimers();
  }
}
async function flushPromise(promise, iterations = 3) {
  for (let i = 0; i < iterations; i++) {
    await new Promise(resolve => (0, _timers.setImmediate)(resolve));
    jest.runOnlyPendingTimers();
  }
  return promise;
}
async function advance(ms, promise) {
  await new Promise(resolve => (0, _timers.setImmediate)(resolve));
  jest.advanceTimersByTime(ms);
  await promise;
}
//# sourceMappingURL=flush.js.map