"use strict";

exports.__esModule = true;
exports.appSettingsMocks = appSettingsMocks;
var _http = require("@wix/bex-utils/@wix/ambassador-app-settings-v1-settings/http");
var _lodash = require("lodash");
function appSettingsMocks(whenRequest) {
  const db = {
    global: {
      settings: {}
    },
    components: {}
  };
  return [whenRequest(_http.getGlobalSettings).reply(200, async data => {
    const {
      host
    } = data;
    return {
      host,
      settings: {
        ...db.global.settings
      }
    };
  }).persist(), whenRequest(_http.getComponentSettings).reply(200, async data => {
    var _db$components$compon;
    const {
      host,
      componentId
    } = data;
    if (componentId == null) {
      throw new Error(`getComponentSettings: Invalid \`componentId\`, received: "${componentId}"`);
    }
    return {
      host,
      settings: {
        ...((_db$components$compon = db.components[componentId]) == null ? void 0 : _db$components$compon.settings)
      }
    };
  }).persist(), whenRequest(_http.setGlobalSettings).reply(200, async data => {
    const {
      host,
      settings
    } = data;
    (0, _lodash.merge)(db.global.settings, settings);
    return {
      host,
      settings
    };
  }).persist(), whenRequest(_http.setComponentSettings).reply(200, async data => {
    var _db$components;
    const {
      host,
      settings,
      componentId
    } = data;
    if (componentId == null) {
      throw new Error(`setComponentSettings: Invalid \`componentId\`, received: "${componentId}"`);
    }
    const component = (_db$components = db.components)[componentId] ?? (_db$components[componentId] = {
      settings: {}
    });
    (0, _lodash.merge)(component.settings, settings);
    return {
      host,
      settings
    };
  }).persist()];
}
//# sourceMappingURL=appSettingsMocks.js.map