"use strict";

exports.__esModule = true;
exports.nestifyItems = nestifyItems;
var _lodash = require("lodash");
function nestifyItems(items, {
  depth,
  setDepthOnItem,
  forceEmptyParentInEachLevel
}) {
  const total = items.length;
  const sampled = [];
  const sampledByLevel = new Map();
  for (let i = 0; i < depth; i++) {
    const sectionSize = Math.floor(i === depth - 1 ? total - sampled.length : total / Math.pow(2, depth - i + 1));
    const section = (0, _lodash.sampleSize)(items.filter(value => !sampled.includes(value)), sectionSize);
    sampled.push(...section);
    sampledByLevel.set(i, section);
    section.forEach(item => {
      var _sampledByLevel$get;
      const parent = i === 0 ? null : (0, _lodash.sample)((_sampledByLevel$get = sampledByLevel.get(i - 1)) == null ? void 0 : _sampledByLevel$get.slice(forceEmptyParentInEachLevel ? 1 : 0));
      setDepthOnItem == null || setDepthOnItem(item, {
        depth: i,
        parent
      });
      item.parentId = (parent == null ? void 0 : parent.id) ?? null;
      if (parent) {
        item.breadcrumbs = [...(parent.breadcrumbs ?? []), {
          id: parent.id,
          name: parent.name
        }];
      }
    });
  }
}
//# sourceMappingURL=nestifyItems.js.map