"use strict";

exports.__esModule = true;
exports.assertKey = assertKey;
exports.assertOneOfKeys = assertOneOfKeys;
exports.assertStringKey = assertStringKey;
function isObject(thing) {
  return thing != null;
}
function assertStringKey(thing, key, {
  errorMessage
} = {}) {
  if (process.env.NODE_ENV !== 'production') {
    if (!isObject(thing) || typeof thing[key] !== 'string') {
      throw new Error((errorMessage == null ? void 0 : errorMessage(key)) ?? `Object must have property: ${key}`);
    }
  }
}
function assertOneOfKeys(thing, keys, {
  errorMessage
} = {}) {
  if (process.env.NODE_ENV !== 'production') {
    if (!isObject(thing) || !keys.some(key => typeof thing[key] === 'string')) {
      throw new Error((errorMessage == null ? void 0 : errorMessage(keys)) ?? `Object must have one of properties: ${keys.join(', ')}`);
    }
  }
}
function assertKey(thing, key, {
  errorMessage
} = {}) {
  if (process.env.NODE_ENV !== 'production') {
    if (!isObject(thing) || !(key in thing)) {
      throw new Error((errorMessage == null ? void 0 : errorMessage(key)) ?? `Object must have property: ${key}`);
    }
  }
}
//# sourceMappingURL=assertKey.js.map