"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.isDetailsResponse = isDetailsResponse;
exports.isErrorDetails = isErrorDetails;
exports.isErrorDetailsHttpError = isErrorDetailsHttpError;
exports.isHttpError = isHttpError;
exports.isServerErrorCode = isServerErrorCode;
var _has = _interopRequireDefault(require("lodash/has"));
function isHttpError(err) {
  return (0, _has.default)(err, 'response');
}
function isErrorDetails(details) {
  return (0, _has.default)(details, 'applicationError') || (0, _has.default)(details, 'validationError');
}
function isDetailsResponse(res) {
  return (0, _has.default)(res, 'details');
}
function isErrorDetailsHttpError(err) {
  var _err$response;
  return isHttpError(err) && isErrorDetails((_err$response = err.response) == null ? void 0 : _err$response.data);
}

// servers errors are 5xx
function isServerErrorCode(err) {
  var _err$response2, _err$response3, _err$response4;
  return isHttpError(err) && typeof (err == null || (_err$response2 = err.response) == null ? void 0 : _err$response2.status) === 'number' && (err == null || (_err$response3 = err.response) == null ? void 0 : _err$response3.status) >= 500 && (err == null || (_err$response4 = err.response) == null ? void 0 : _err$response4.status) < 600;
}
//# sourceMappingURL=isHttpError.js.map