"use strict";

exports.__esModule = true;
exports.fqdnToString = fqdnToString;
exports.isFqdnValid = isFqdnValid;
exports.parseFqdn = parseFqdn;
const FQDN_REGEX = /^wix\.(.+)\.(v\d+)\.(.+)$/;
function parseFqdn(fqdnString) {
  var _domainAndProduct$spl;
  const result = fqdnString.match(FQDN_REGEX);
  if (result == null) {
    return {
      product: fqdnString
    };
  }
  const [, domainAndProduct, version, resource] = result;
  const [product, domain] = (domainAndProduct == null || (_domainAndProduct$spl = domainAndProduct.split('.')) == null ? void 0 : _domainAndProduct$spl.reverse()) ?? [];
  return {
    domain,
    product,
    resource,
    version
  };
}
function fqdnToString(fqdn) {
  return ['wix', ...[fqdn.domain, fqdn.product, fqdn.version, fqdn.resource].filter(Boolean)].join('.');
}
function isFqdnValid(fqdn) {
  return fqdn.resource !== undefined;
}
//# sourceMappingURL=parseFqdn.js.map