import { parseFqdn } from '../util/parseFqdn';
import { CollectionState, } from '../state';
import { QueryCache } from 'react-query/core';
export function createCollection(container, config, { paginationModeRef, overrides } = {}) {
    const { errorMonitor, errorHandler, onlineState, history, translate, queryCache, showToast, initialFetch, lodash, } = container;
    const { queryName, fqdn } = config;
    // fallbacks to queryName for backwards compatibility
    const parsedFqdn = parseFqdn(fqdn || queryName);
    return new CollectionState({
        ...config,
        queryName,
        fqdn: parsedFqdn,
        paginationModeRef,
        queryCache: overrides?.queryCache ??
            (typeof process !== 'undefined' && process.env.STORYBOOK_DOCS === 'true'
                ? new QueryCache()
                : queryCache),
        history,
        errorMonitor,
        errorHandler,
        showToast: overrides?.showToast ?? showToast,
        translate,
        onlineState,
        initDependencies: initialFetch,
        lodash,
    });
}
//# sourceMappingURL=createCollection.js.map