import { useCallback, useState } from 'react';
import { useWixPatternsContainer, useWixPatternsContainerOverrides, } from '../../providers';
import { createCollection as createCollectionBase } from '../createCollection';
import { createCollectionConfig } from '../createCollectionConfig';
export function usePrivateCreateCollection() {
    const container = useWixPatternsContainer();
    const overrides = useWixPatternsContainerOverrides();
    return useCallback((config, options = {}) => createCollectionBase(container, createCollectionConfig(config), {
        ...options,
        overrides,
    }), []);
}
export function useCreateCollection() {
    const createCollection = usePrivateCreateCollection();
    return useCallback((config) => createCollection(config), []);
}
export function useCollection(config) {
    const createCollection = useCreateCollection();
    const [collection] = useState(() => createCollection(config));
    return collection;
}
//# sourceMappingURL=useCollection.js.map