import { useWixPatternsContainer, useCollectionContext, useCollectionPageContext, } from '../providers';
import { ExportState, } from '../state';
import { useCallback } from 'react';
export function useCreateExport(params) {
    const collection = useCollectionContext();
    const collectionPageState = useCollectionPageContext();
    const { createExportAsyncJobRequest, transformPlatformizedQuery, differentQueryEndpointThanCollection, customTotal, reportBi, exportModalState, saveAs, } = params;
    const { httpClient, showToast, translate, window, internalMonitor, onlineState, errorHandler, } = useWixPatternsContainer();
    return useCallback(() => {
        return new ExportState({
            transformPlatformizedQuery,
            createExportAsyncJobRequest,
            saveAs,
            httpClient,
            showToast,
            translate,
            collection,
            differentQueryEndpointThanCollection,
            customTotal,
            reportBi,
            exportModalState,
            collectionPageState,
            window,
            onlineState,
            internalMonitor,
            errorHandler,
        });
    }, []);
}
//# sourceMappingURL=useExport.js.map