import { useCallback, useEffect, useState } from 'react';
import { CollectionOptimisticActions, } from '../state';
import { useWixPatternsContainer } from '../providers';
export function useCreateOptimisticActions() {
    const container = useWixPatternsContainer();
    return useCallback((collection, params) => collection._optimisticActions ??
        new CollectionOptimisticActions({
            container,
            collection,
            ...params,
        }), []);
}
export function useOptimisticActions(collection, params) {
    const createOptimisticActions = useCreateOptimisticActions();
    const [optimisticActions] = useState(() => createOptimisticActions(collection, params));
    useEffect(() => optimisticActions.init(), []);
    return optimisticActions;
}
//# sourceMappingURL=useOptimisticActions.js.map