import { useCallback, useState } from 'react';
import { useCreateCollection } from './useCollection';
import { PickerState } from '../state';
import { useWixPatternsContainer } from '../providers';
export function useCreatePicker() {
    const { createBILogger } = useWixPatternsContainer();
    const createCollection = useCreateCollection();
    return useCallback((config) => {
        const { events, ...collectionConfig } = config;
        const collection = createCollection({
            ...collectionConfig,
            events,
        });
        return new PickerState({
            getMaxItems: () => undefined,
            collection,
            events,
            reportBi: createBILogger({
                ...collection.fqdn,
            }),
        });
    }, []);
}
export function usePicker(config) {
    const createPickerStandalone = useCreatePicker();
    const [state] = useState(() => createPickerStandalone(config));
    return state;
}
//# sourceMappingURL=usePicker.js.map