import { useEffect, useState } from 'react';
import { makeObservable, runInAction } from 'mobx';
export function useSyncProps(props, annotations) {
    const [syncedProps] = useState(() => makeObservable(props, annotations, {
        deep: false,
    }));
    // sync all props using Object.assign on every render (as not passing deps to useEffect)
    useEffect(() => {
        runInAction(() => {
            Object.assign(syncedProps, props);
        });
    });
    return syncedProps;
}
//# sourceMappingURL=useSyncProps.js.map