import { DataCapsuleMergeStrategy } from './DataCapsuleMergeStrategy';
import { mapGuidComponentIdToNonGuid } from './mapGuidComponentIdToNonGuid';
export const createComponentSettings = ({ createEssentials, environment, }) => {
    return (options) => {
        const { dataCapsule: _dataCapsule } = createEssentials({
            dataCapsule: {
                storageStrategy: 'userPreferences',
                namespace: options.namespace,
                scope: mapGuidComponentIdToNonGuid(environment.componentId || environment.artifactId),
            },
        });
        const componentSettings = _dataCapsule;
        componentSettings.storageStrategy = new DataCapsuleMergeStrategy({
            storage: componentSettings.storageStrategy,
        });
        return _dataCapsule;
    };
};
//# sourceMappingURL=createComponentSettings.js.map