import { action, makeObservable, observable } from 'mobx';
import { ModalState } from './ModalState';
export class ConditionalModalState {
    constructor(params) {
        this.value = null;
        this.modal = new ModalState(params);
        makeObservable(this, {
            value: observable.ref,
            afterClose: action.bound,
            open: action.bound,
            close: action.bound,
        });
    }
    get isOpen() {
        return this.modal.isOpen;
    }
    close() {
        this.modal.close();
    }
    afterClose() {
        this.value = null;
    }
    open(value) {
        this.value = value;
        this.modal.open();
    }
}
//# sourceMappingURL=ConditionalModalState.js.map