import { commonExportAsyncJobErrors } from './commonExportAsyncJobErrors';
export const getExportAsyncJobErrors = ({ translate: t, retryFn, }) => {
    return {
        applicationError: {
            job_not_found: () => ({
                message: t('cairo.export.GetExportAsyncJob.job-not-found.error'),
                action: {
                    text: t('cairo.error.tryAgain.cta'),
                    onClick: retryFn,
                },
            }),
            get_async_job_internal: () => ({
                message: t('cairo.export.get-async-job.error.internal'),
                action: {
                    text: t('cairo.error.tryAgain.cta'),
                    onClick: retryFn,
                },
            }),
            method_endpoint_permission_denied: false,
        },
        statusCodeError: {
            ...commonExportAsyncJobErrors({ translate: t }),
        },
    };
};
//# sourceMappingURL=getExportAsyncJobErrors.js.map