import { PaginationModeCursor } from './PaginationModeCursor';
import { PaginationModeOffset } from './PaginationModeOffset';
export class PaginationMode {
    constructor(collection) {
        this.collection = collection;
        this.cursorMode = new PaginationModeCursor({ collection });
        this.offsetMode = new PaginationModeOffset({ collection });
    }
    get mode() {
        return this.collection._paginationModeRef.current === 'cursor'
            ? this.cursorMode
            : this.offsetMode;
    }
    get fetchedLastPage() {
        return this.mode.fetchedLastPage;
    }
    setCursor(cursor) {
        this.mode.setCursor(cursor);
    }
    get id() {
        return this.mode.id;
    }
}
//# sourceMappingURL=PaginationMode.js.map