import { action, computed, makeObservable } from 'mobx';
export class PaginationModeCursor {
    constructor(params) {
        this.collection = params.collection;
        makeObservable(this, {
            fetchedLastPage: computed,
            setCursor: action,
        });
    }
    get fetchedLastPage() {
        const { query: { pagination: { cursor }, }, } = this.collection;
        return cursor == null;
    }
    setCursor(cursor) {
        const { query } = this.collection;
        query.pagination.cursor = cursor;
    }
    get id() {
        return PaginationModeCursor.id;
    }
}
PaginationModeCursor.id = 'cursor';
//# sourceMappingURL=PaginationModeCursor.js.map