import { action, computed, makeObservable, observable, runInAction, } from 'mobx';
import { PromiseState } from './PromiseState';
export class PromisesState {
    constructor() {
        this.promises = observable.array([], {
            deep: false,
        });
        makeObservable(this, {
            push: action.bound,
            addPromise: action.bound,
            isLoadingPromises: computed,
        });
    }
    async addPromise(createPromise) {
        return this.push(new PromiseState({
            createPromise,
        }));
    }
    async push(promise) {
        this.promises.push(promise);
        await promise.fetch();
        runInAction(() => {
            this.promises.remove(promise);
        });
    }
    get isLoadingPromises() {
        return this.promises.some((promise) => promise.status.isLoading);
    }
}
//# sourceMappingURL=PromisesState.js.map