function getKey(item, maybeKeyOfT) {
    return item[maybeKeyOfT];
}
export class QueryResultSimulationDefault {
    constructor(params) {
        this.orderBy = (computedQuery) => {
            const { sort } = computedQuery;
            return [...(sort ?? [])];
        };
        this.predicate = (computedQuery) => {
            const { collection } = this;
            const { query, itemName } = collection;
            const { search, filters } = computedQuery;
            return (item) => {
                for (const [filterName, value] of Object.entries(filters)) {
                    const filter = query.filters[filterName];
                    if (filter == null) {
                        return false;
                    }
                    const fieldValue = getKey(item, filterName);
                    if (value != null &&
                        fieldValue != null &&
                        !filter.matches(fieldValue, value)) {
                        return false;
                    }
                }
                if (search && !itemName(item).toLowerCase().includes(search)) {
                    return false;
                }
                return true;
            };
        };
        this.collection = params.collection;
    }
}
//# sourceMappingURL=QueryResultSimulationDefault.js.map