import { observable, runInAction } from 'mobx';
import { EventEmitter } from 'events';
export class SelectMapState {
    constructor() {
        this.events = new EventEmitter();
        this.map = observable.map([], {
            deep: false,
        });
    }
    set(key, value) {
        if (this.events.listeners('isDisabled').some((listener) => listener(value))) {
            return;
        }
        runInAction(() => {
            this.map.set(key, value);
        });
    }
    forceSet(key, value) {
        runInAction(() => {
            this.map.set(key, value);
        });
    }
    get(key) {
        return this.map.get(key);
    }
    values() {
        return this.map.values();
    }
    entries() {
        return this.map.entries();
    }
    clear() {
        return this.map.clear();
    }
}
//# sourceMappingURL=SelectMapState.js.map