import { action, makeObservable, observable } from 'mobx';
// just because observable.box doesn't wrap `.set()` with action
export class ValueBox {
    constructor(initialValue) {
        this._value = initialValue;
        makeObservable(this, {
            _value: observable.ref,
            set: action.bound,
        });
    }
    set(value) {
        this._value = value;
    }
    get value() {
        return this._value;
    }
    set value(value) {
        this.set(value);
    }
}
//# sourceMappingURL=ValueBox.js.map