export function getJobItemsAbsoluteCounter(job, { query, totalForExport }) {
    const paging = query.paging ?? query.cursorPaging;
    const getOffset = () => {
        if (job.data?.processedItemsCount != null) {
            return job.data.processedItemsCount;
        }
        if (job.data?.pagingMetadata?.offset != null) {
            return Math.max(job.data.pagingMetadata.offset - paging?.limit, 0);
        }
        const iterationsCount = job.data?.iterationsCount ?? 0;
        return Math.max(iterationsCount - 1, 0) * paging?.limit;
    };
    const processedItemsCount = getOffset();
    return totalForExport
        ? Math.min(processedItemsCount, totalForExport)
        : processedItemsCount;
}
//# sourceMappingURL=getJobItemsAbsoluteCounter.js.map