export function addMutationObserver(element, cb) {
    if (element == null) {
        return;
    }
    if (typeof MutationObserver === 'undefined') {
        return;
    }
    const mutationObserver = new MutationObserver(cb);
    mutationObserver.observe(element, {
        childList: true,
        subtree: true,
        attributes: false,
        characterData: false,
    });
    return () => {
        mutationObserver.disconnect();
    };
}
//# sourceMappingURL=mutationObserverCompat.js.map