import orderBy from 'lodash/orderBy';
import { trimAddedItemsFromPagePredicate } from './trimAddedItemsFromPagePredicate';
export function orderByOrders(pageWithPatchedItems, toMerge, { limit, itemKey, orders, }) {
    const pageWithPatchedItemsOrdered = orders.length
        ? orderBy(pageWithPatchedItems, orders.map(({ fieldName }) => {
            const fn = typeof fieldName === 'function'
                ? fieldName
                : (e) => e[fieldName];
            return ({ item, orderByItem }, index) => {
                const finalItem = orderByItem ?? item;
                return fn(finalItem, index);
            };
        }), orders.map(({ order }) => order))
        : pageWithPatchedItems;
    return pageWithPatchedItemsOrdered
        .map(({ item }) => item)
        .filter(trimAddedItemsFromPagePredicate({
        addedItems: toMerge.all,
        itemKey,
        limit,
    }));
}
//# sourceMappingURL=orderByOrders.js.map