import { ValueBox } from './ValueBox';
import { action, makeObservable, reaction, runInAction } from 'mobx';
export class Snapshot {
    constructor(params) {
        this.box = new ValueBox(runInAction(() => params.effect()));
        this.expression = params.expression;
        this.effect = params.effect;
        makeObservable(this, {
            init: action,
            forceUpdate: action,
        });
    }
    get value() {
        return this.box.value;
    }
    set value(v) {
        this.box.value = v;
    }
    forceUpdate() {
        this.value = this.effect();
    }
    init() {
        const { box, effect } = this;
        const dispose = reaction(this.expression, () => {
            box.set(effect());
        });
        return () => {
            dispose();
        };
    }
}
//# sourceMappingURL=snapshot.js.map