import { sample, sampleSize } from 'lodash';
export function nestifyItems(items, { depth, setDepthOnItem, forceEmptyParentInEachLevel, }) {
    const total = items.length;
    const sampled = [];
    const sampledByLevel = new Map();
    for (let i = 0; i < depth; i++) {
        const sectionSize = Math.floor(i === depth - 1
            ? total - sampled.length
            : total / Math.pow(2, depth - i + 1));
        const section = sampleSize(items.filter((value) => !sampled.includes(value)), sectionSize);
        sampled.push(...section);
        sampledByLevel.set(i, section);
        section.forEach((item) => {
            const parent = i === 0
                ? null
                : sample(sampledByLevel
                    .get(i - 1)
                    ?.slice(forceEmptyParentInEachLevel ? 1 : 0));
            setDepthOnItem?.(item, {
                depth: i,
                parent,
            });
            item.parentId = parent?.id ?? null;
            if (parent) {
                item.breadcrumbs = [
                    ...(parent.breadcrumbs ?? []),
                    { id: parent.id, name: parent.name },
                ];
            }
        });
    }
}
//# sourceMappingURL=nestifyItems.js.map