function isObject(thing) {
    return thing != null;
}
export function assertStringKey(thing, key, { errorMessage, } = {}) {
    if (process.env.NODE_ENV !== 'production') {
        if (!isObject(thing) || typeof thing[key] !== 'string') {
            throw new Error(errorMessage?.(key) ?? `Object must have property: ${key}`);
        }
    }
}
export function assertOneOfKeys(thing, keys, { errorMessage, } = {}) {
    if (process.env.NODE_ENV !== 'production') {
        if (!isObject(thing) ||
            !keys.some((key) => typeof thing[key] === 'string')) {
            throw new Error(errorMessage?.(keys) ??
                `Object must have one of properties: ${keys.join(', ')}`);
        }
    }
}
export function assertKey(thing, key, { errorMessage, } = {}) {
    if (process.env.NODE_ENV !== 'production') {
        if (!isObject(thing) || !(key in thing)) {
            throw new Error(errorMessage?.(key) ?? `Object must have property: ${key}`);
        }
    }
}
//# sourceMappingURL=assertKey.js.map