import has from 'lodash/has';
export function isHttpError(err) {
    return has(err, 'response');
}
export function isErrorDetails(details) {
    return has(details, 'applicationError') || has(details, 'validationError');
}
export function isDetailsResponse(res) {
    return has(res, 'details');
}
export function isErrorDetailsHttpError(err) {
    return isHttpError(err) && isErrorDetails(err.response?.data);
}
// servers errors are 5xx
export function isServerErrorCode(err) {
    return (isHttpError(err) &&
        typeof err?.response?.status === 'number' &&
        err?.response?.status >= 500 &&
        err?.response?.status < 600);
}
//# sourceMappingURL=isHttpError.js.map