import { isHttpError } from './isHttpError';
export function shouldRedirectToLogin(err, includeNetworkError) {
    if (isHttpError(err)) {
        const { response, message } = err;
        // Axios redirects by default, so instead of getting 302, we get network error
        // As a workaround we assume that in case of a network error, currently online and retried few times we should redirect to login
        // https://github.com/axios/axios/issues/932
        return (response?.status === 401 ||
            (includeNetworkError && message === 'Network Error'));
    }
    return false;
}
//# sourceMappingURL=shouldRedirectToLogin.js.map