export type QueryStatusValue = 'idle' | 'loading' | 'error' | 'success';
export interface QueryStatusBase {
    status: QueryStatusValue;
}
export interface QueryStatusIdle extends QueryStatusBase {
    isError: false;
    isIdle: true;
    isLoading: false;
    isSuccess: false;
    status: 'idle';
}
export interface QueryStatusLoading extends QueryStatusBase {
    isError: false;
    isIdle: false;
    isLoading: true;
    isSuccess: false;
    status: 'loading';
}
export interface QueryStatusError extends QueryStatusBase {
    isError: true;
    isIdle: false;
    isLoading: false;
    isSuccess: false;
    status: 'error';
}
export interface QueryStatusSuccess extends QueryStatusBase {
    isError: false;
    isIdle: false;
    isLoading: false;
    isSuccess: true;
    status: 'success';
}
export type QueryStatus = QueryStatusIdle | QueryStatusLoading | QueryStatusError | QueryStatusSuccess;
export declare const idle: QueryStatusIdle;
export declare const loading: QueryStatusLoading;
export declare const error: QueryStatusError;
export declare const success: QueryStatusSuccess;
export declare const queryStatus: {
    idle: QueryStatusIdle;
    loading: QueryStatusLoading;
    error: QueryStatusError;
    success: QueryStatusSuccess;
};
//# sourceMappingURL=queryStatus.d.ts.map