import type { BaseStorage, BaseStorageOptions } from '@wix/fe-essentials/data-capsule';
import { Scope } from '@wix/data-capsule/dist/types/base-storage';
export interface AccountPreferencesMergeStrategyParams {
    readonly storage: BaseStorage<BaseStorageOptions>;
}
export interface AppSettingsViewsSchema {
    views?: {
        list?: Record<string, {} | null | undefined>;
    };
}
export declare class AccountPreferencesMergeStrategy implements BaseStorage<BaseStorageOptions> {
    private readonly storage;
    constructor(params: AccountPreferencesMergeStrategyParams);
    extendScope(scope: Scope): Scope;
    setItem<T>(key: string, value: T, options: BaseStorageOptions): Promise<void>;
    removeItem(key: string, options: BaseStorageOptions): Promise<void>;
    getItem<T = any>(key: string, options: BaseStorageOptions): Promise<T>;
    getAllItems<T = any>(options: BaseStorageOptions): Promise<T>;
}
//# sourceMappingURL=AccountPreferencesMergeStrategy.d.ts.map