import type { BaseStorage, BaseStorageOptions } from '@wix/fe-essentials/data-capsule';
import { WixPatternsEssentials } from '../model';
export interface WixStorageStrategyOptions extends BaseStorageOptions {
    expiration: number;
}
export interface AccountPreferencesStrategyParams {
    readonly httpClient: WixPatternsEssentials['httpClient'];
}
export declare class AccountPreferencesStrategy implements BaseStorage<WixStorageStrategyOptions> {
    private readonly httpClient;
    readonly accountPrefHttpPath = "/_api/app-settings-service/v1/accountPreferences";
    constructor(params: AccountPreferencesStrategyParams);
    extendScope(scope: Required<WixStorageStrategyOptions>['scope']): import("@wix/data-capsule/dist/types/base-storage").Scope;
    getAllItems<T>(options: WixStorageStrategyOptions): Promise<T>;
    getItem<T>(key: string, options: WixStorageStrategyOptions): Promise<T>;
    removeItem(key: string, options: WixStorageStrategyOptions): Promise<void>;
    setItem<T>(key: string, value: T, options: WixStorageStrategyOptions): Promise<void>;
}
//# sourceMappingURL=AccountPreferencesStrategy.d.ts.map