import { WixPatternsEssentials, DataCapsule } from '../model';
import { Host } from '@wix/bex-utils/@wix/ambassador-app-settings-v1-settings/types';
import { QueryCache, QueryClient } from 'react-query/core';
export interface AppSettingsCapsuleParams {
    readonly httpClient: WixPatternsEssentials['httpClient'];
    readonly context: {
        namespace: string;
        componentId: string;
        host: Host;
    };
    queryCache: QueryCache;
}
export declare class AppSettingsCapsule implements DataCapsule {
    readonly httpClient: import("../model/httpClient").HttpClient;
    readonly context: {
        namespace: string;
        componentId: string;
        host: Host;
    };
    readonly queryClient: QueryClient;
    readonly queryCache: QueryCache;
    constructor(params: AppSettingsCapsuleParams);
    _buildAppSettingsPayload<P>(payload: P): P & {
        componentId?: string | undefined;
    };
    _getQueryKey(): (string | {
        namespace: string;
        componentId: string;
        host: Host;
    })[];
    getItem<T>(key: string): Promise<T>;
    setItem<T>(key: string, value: T): Promise<void>;
    removeItem(key: string): Promise<void>;
}
//# sourceMappingURL=AppSettingsCapsule.d.ts.map