import { WixPatternsErrorCode } from './WixPatternsErrorCode';
export declare function isWixPatternsError(err: unknown): err is WixPatternsError;
export declare function isError(err: unknown): err is Error;
export declare class WixPatternsError extends Error {
    readonly originalException: unknown;
    readonly extraData: Object | undefined;
    /**
     * This class is used to create a cairo error that occur within the application. It takes in an object with the following properties:
     * @param errorCode A WixPatternsErrorCode enum value representing the error that occurred.
     * @param originalException (optional) The exception that was thrown.
     * @param extraData (optional) Additional data related to the error.
     */
    constructor({ errorCode, originalException, extraData, }: {
        errorCode: WixPatternsErrorCode;
        extraData?: Object;
        originalException?: unknown;
    });
}
//# sourceMappingURL=WixPatternsError.d.ts.map