import { TypedEmitter } from '../util';
import { PartialWindow } from './partialWindow';
interface NavigationEventState {
    prevented: boolean;
    pause: () => {
        resume: () => unknown;
    };
}
export declare class NavigationManager {
    window: PartialWindow;
    constructor(window: PartialWindow);
    readonly events: TypedEmitter<{
        navigation: (state: NavigationEventState) => unknown;
        navigationPromptResult: (leave: boolean) => unknown;
    }>;
    navigate(url: string): void;
    navigateToPage({ pageId }: {
        pageId: string;
    }): void;
    confirmLeavePage(): void;
    subscribe(onNavigation: (state: NavigationEventState) => unknown): () => void;
}
export {};
//# sourceMappingURL=navigationManager.d.ts.map