import { CreateTagApplicationErrors, CreateTagRequest, DeleteTagRequest, DeleteTagResponse, ListTagsRequest, Tag, UpdateTagRequest } from '@wix/bex-utils/@wix/ambassador-os-tags-v1-tag/types';
import { WixPatternsContainer } from '../../state';
import { ErrorCodesMap, ErrorCodesMapRequiredApplicationError } from '@wix/fe-essentials/error-handler';
export interface TagsServiceParams {
    readonly container: WixPatternsContainer;
}
export declare class TagsService {
    private readonly container;
    constructor({ container }: TagsServiceParams);
    private get httpClient();
    private getContextFunction;
    listTags(request: ListTagsRequest, errorCodesMap: ErrorCodesMap): Promise<Tag[]>;
    createTag(request: CreateTagRequest, errorCodesMap: ErrorCodesMapRequiredApplicationError<CreateTagApplicationErrors>): Promise<Tag>;
    updateTag(request: UpdateTagRequest): Promise<Tag>;
    deleteTag(request: DeleteTagRequest): Promise<DeleteTagResponse>;
}
//# sourceMappingURL=tagsService.d.ts.map