import { TaskState } from './TaskState';
import { WixPatternsContainer } from './WixPatternsContainer';
import { MarketListing } from '@wix/bex-utils/@wix/ambassador-devcenter-app-market-listing-v1-market-listing/types';
import { DataExtensionState } from './DataExtensionState';
export interface AppsStateParams {
    container: WixPatternsContainer;
    dataExtension: DataExtensionState;
}
export declare class AppsState {
    readonly initTask: TaskState<unknown>;
    readonly container: WixPatternsContainer;
    readonly dataExtension: DataExtensionState;
    apps: MarketListing[];
    constructor(params: Readonly<AppsStateParams>);
    init(): () => void;
    _fetchApps(appIds: string[]): Promise<void>;
    get appNames(): Record<string, string>;
    private _sortByEnglishFirst;
    private _extractAppNames;
    private _getAppsRequests;
    private _aggregateAppsFromResponses;
}
//# sourceMappingURL=AppsState.d.ts.map