import { ReactNode } from 'react';
import { ConditionalModalState } from './ConditionalModalState';
import { Translate } from '../services';
interface MessageModalLayoutProps {
    title?: string | ReactNode;
    content?: string | ReactNode;
    primaryButtonText?: string | ReactNode;
    secondaryButtonText?: string | ReactNode;
    theme?: 'standard' | 'premium' | 'destructive';
}
export interface BulkActionModalParams {
    readonly translate: Translate;
    readonly scrollToTop: () => unknown;
}
export declare class BulkActionModalState {
    readonly translate: Translate;
    readonly scrollToTop: () => unknown;
    readonly actionModal: ConditionalModalState<Partial<MessageModalLayoutProps>>;
    constructor(params: BulkActionModalParams);
    openModal: () => void;
    closeModal: () => void;
    closeModalAndScrollTop: () => void;
    openConfirmModal: (props?: Partial<MessageModalLayoutProps>) => void;
    get isModalOpen(): boolean;
}
export {};
//# sourceMappingURL=BulkActionModalState.d.ts.map