import { CollectionState } from './CollectionState';
import { TypedEmitter } from '../util';
import { FiltersMap } from '../model';
import { ReportBI } from '../services';
export interface CollectionBIReporterParams<T, F extends FiltersMap> {
    readonly collection: CollectionState<T, F>;
    readonly reportBi: ReportBI;
}
export declare class CollectionBIReporter<T, F extends FiltersMap> {
    readonly collection: CollectionState<T, F>;
    readonly reportBi: ReportBI;
    readonly events: TypedEmitter<{
        sortStart: (params: {
            col: {
                id: string;
            };
        }) => unknown;
    }>;
    sortedColumnId: string;
    constructor(params: CollectionBIReporterParams<T, F>);
    init(): () => void;
    _getSortDirection(columndId?: string): import("../model").SortOrder | "removed";
    _getSortOrder(): string;
}
//# sourceMappingURL=CollectionBIReporter.d.ts.map