import { IObservableArray } from 'mobx';
import { OptimisticPatch } from './CollectionOptimisticPatch';
export interface CollectionOptimisticActionsStateParams<T> {
    readonly patchesCache: Map<string, IObservableArray<OptimisticPatch<T>>>;
    readonly source: {
        queryName: string;
    };
    readonly cacheNamespace?: string;
}
export declare class CollectionOptimisticActionsState<T> {
    readonly patches: IObservableArray<OptimisticPatch<T>>;
    _patchesBeforeUnmount: OptimisticPatch<T>[] | null;
    constructor(params: CollectionOptimisticActionsStateParams<T>);
    get latestMap(): Map<string, {
        item: T;
        originalItem: T;
        optimisticPatch: OptimisticPatch<T>;
    }>;
}
//# sourceMappingURL=CollectionOptimisticActionsState.d.ts.map