import { WixPatternsContainer } from './WixPatternsContainer';
import { Fqdn } from '../model';
import { TaskState } from './TaskState';
import { DataExtensionState } from './DataExtensionState';
import { ExtendedFields } from '../services';
import { AppsState } from './AppsState';
export interface CustomFieldsViewWidgetStateParams {
    readonly container: WixPatternsContainer;
    readonly fqdn: Fqdn;
    readonly url: string;
    readonly route?: string;
    readonly theme?: 'inline' | 'card';
    readonly extensionPoint?: string;
}
export declare class CustomFieldsViewWidgetState {
    readonly container: WixPatternsContainer;
    readonly dataExtension: DataExtensionState;
    readonly apps: AppsState;
    readonly initTask: TaskState<unknown>;
    readonly reportBi: import("../services").ReportBI;
    readonly startTime: number;
    readonly url: string;
    readonly route: string | undefined;
    readonly theme: "inline" | "card" | undefined;
    readonly userFieldsNamespace: string;
    constructor(params: CustomFieldsViewWidgetStateParams);
    init(): void;
    onInitError(err: Error): void;
    retry(): void;
    get isLoading(): boolean;
    get isError(): boolean;
    getExtendedFieldsToDisplayForNamespace(namespace: string, extendedFields?: ExtendedFields): import("../services").CustomField[];
    getAppName(namespace: string): string;
}
//# sourceMappingURL=CustomFieldsViewWidgetState.d.ts.map