import { ExportState, SelectedExportOption } from './ExportState';
import { FiltersMap } from '../../model';
import { ReportProps } from '@wix/fe-essentials/bi';
import { ExportAsyncJob, ExportQueryV2 as QueryV2 } from '@wix/bex-utils/@wix/ambassador-fedinfra-exportservice-v1-export-async-job/types';
export declare class ExportStateBIReporter<T, F extends FiltersMap> {
    private readonly state;
    private readonly exportBiUniqueId;
    constructor(state: ExportState<T, F>);
    get reportBi(): import("../..").ReportBI;
    _reportWithDefaultParams(reportProps: ReportProps): Promise<void>;
    _reportWithSelectedExportParams(reportProps: ReportProps): Promise<void>;
    onExportTypeChange({ prev, next, }: {
        prev: SelectedExportOption;
        next: SelectedExportOption;
    }): void;
    clickOpenModal(): void;
    beforeToast(): {
        startTime: number;
    };
    onToastActionClick({ startTime }: {
        startTime: number;
    }): void;
    onRetryExportToClick(): void;
    onFailedCancel(): void;
    onFailedClose(): void;
    onExportToClick(): void;
    onExportStart(): ({ job, query, result, saveAs, }: {
        job: ExportAsyncJob | null;
        query: QueryV2;
        result: 'success' | 'fail' | 'stopped by user';
        saveAs?: string | undefined;
    }) => Promise<void>;
    onCancelClick(): void;
    onCancelExportButtonClick(): void;
    onCancelExportGoBackButtonClick(): void;
    onCancelExportCloseButtonClick(): void;
    onExportCloseAttemptClick(): void;
    onExportCancelAttemptClick(): void;
    onCloseClick(): void;
    onToastDismissed({ startTime, by: dismissMode, }: {
        startTime: number;
        by: 'manual' | 'automatic';
    }): void;
}
//# sourceMappingURL=ExportStateBIReporter.d.ts.map