import { CollectionState } from './CollectionState';
import { QueryCache } from 'react-query';
import { ComputedQuery, FiltersMap, QueryStatusValue } from '../model';
export interface FetchTotalStateParams<T, F extends FiltersMap> {
    readonly collection: CollectionState<T, F>;
    readonly queryCache: QueryCache;
    readonly fetchTotal: (query: ComputedQuery<F>) => Promise<number>;
}
export declare class FetchTotalState<T, F extends FiltersMap> {
    readonly _collection: CollectionState<T, F>;
    readonly _totalsCollection: CollectionState<T, F>;
    constructor(params: Readonly<FetchTotalStateParams<T, F>>);
    init(): () => void;
    get total(): number;
    get status(): QueryStatusValue;
}
//# sourceMappingURL=FetchTotalState.d.ts.map