import { CollectionState } from './CollectionState';
import { DataResultKeyed, FiltersMap, QueryResultStatusError } from '../model';
import { TaskState } from './TaskState';
export interface MultiCollectionSupportParams<F extends FiltersMap> {
    readonly collections: CollectionState<any, F>[];
}
export declare class MultiCollectionSupport<F extends FiltersMap> {
    readonly collections: CollectionState<unknown, F>[];
    readonly initTask: TaskState<unknown>;
    constructor(params: MultiCollectionSupportParams<F>);
    get showInitialLoader(): boolean;
    get showEmptyState(): boolean;
    get showErrorState(): boolean;
    get showRefreshLoader(): boolean;
    get showLoadingState(): boolean;
    get errorStatus(): QueryResultStatusError<DataResultKeyed<unknown>, F> | undefined;
    get hasAvailableItems(): boolean;
    get hasNonPersistentActiveFilters(): boolean;
    get hasNonPersistentCustomFilters(): boolean;
    get resultOriginQuerySearch(): string | undefined;
    get resultOriginQueryRawSearch(): string;
    retryErrorState: () => void;
    init({ skipFilterListeners, }?: {
        skipFilterListeners?: boolean;
    }): () => void;
}
//# sourceMappingURL=MultiCollectionSupport.d.ts.map