import { FocusManager, OnlineManager, Translate } from '../services';
import { TypedEmitter } from '../util';
import { ShowToast } from '../model';
export interface OnlineStateParams {
    readonly onlineManager: OnlineManager;
    readonly focusManager: FocusManager;
    readonly showToast?: ShowToast;
    readonly translate: Translate;
}
export declare class OnlineState {
    readonly onlineManager: OnlineManager;
    readonly focusManager: FocusManager;
    readonly showToast: ShowToast | undefined;
    readonly translate: Translate;
    readonly events: TypedEmitter<{
        change: (isOnline: boolean) => void;
    }>;
    _removeOfflineToastTimeoutId: ReturnType<typeof setTimeout> | null;
    _removeOfflineToast: (() => void) | null;
    constructor(params: OnlineStateParams);
    get isOnline(): boolean;
    showOfflineToast(): void;
    init(): () => void;
}
//# sourceMappingURL=OnlineState.d.ts.map