import { PaginationModeCursor } from './PaginationModeCursor';
import { PaginationModeOffset } from './PaginationModeOffset';
import { CollectionState } from './CollectionState';
import { FiltersMap } from '../model';
export type PaginationModeRef = {
    current: 'offset' | 'cursor' | undefined;
};
export declare class PaginationMode<T, F extends FiltersMap = FiltersMap> {
    readonly collection: CollectionState<T, F>;
    readonly cursorMode: PaginationModeCursor<T, F>;
    readonly offsetMode: PaginationModeOffset<T, F>;
    constructor(collection: CollectionState<T, F>);
    get mode(): PaginationModeCursor<T, F> | PaginationModeOffset<T, F>;
    get fetchedLastPage(): boolean;
    setCursor(cursor: string | null): void;
    get id(): "cursor" | "offset";
}
//# sourceMappingURL=PaginationMode.d.ts.map