import { FilterItem } from '../../model';
import { RangeItem } from './RangeFilterState';
import { Translate, TranslationsKeys } from '../../services';
export declare const DateRangePreset: Record<DateRangePresetOptions, string>;
export declare const DefaultDateRangePreset: Record<'NONE' | 'SEVEN_DAYS' | 'FOURTEEN_DAYS' | 'MONTH' | 'CUSTOM', string>;
export declare const renderPresetToolbarTag: (container: {
    translate: Translate;
    dateFormatters: {
        medium: Intl.DateTimeFormat;
        mediumTime: Intl.DateTimeFormat;
    };
}) => <V>(filter: FilterItem<V>) => {
    children: string;
};
export declare const shouldRenderPresetTag: (preset?: string) => boolean | "" | undefined;
export declare const presetToDaysAmount: {
    [key: string]: {
        months?: number;
        days?: number;
        years?: number;
    };
};
export declare const getDatesFromPreset: (preset?: string) => RangeItem<Date>;
export declare const MAP_DATE_PRESET_TO_KEY: {
    [key: string]: TranslationsKeys;
};
export type DateRangeFilterMode = 'ONLY_PREDEFINED' | 'ONLY_CUSTOM' | 'COMBINE';
export type DateRangePredefinedPresetOptions = 'SEVEN_DAYS' | 'FOURTEEN_DAYS' | 'MONTH' | 'TODAY' | 'TOMORROW' | 'NEXT_THREE_DAYS' | 'NEXT_SEVEN_DAYS' | 'NEXT_THIRTY_DAYS';
export type DateRangePresetOptions = DateRangePredefinedPresetOptions | 'NONE' | 'CUSTOM';
export type DateRangeOptions = DateRangePredefinedPresetOptions[];
//# sourceMappingURL=dateRangeUtils.d.ts.map