import { cairoTagsAddDeleteTagParams as TagsAddDeleteTagParams, cairoTagsModalEndProcessParams as TagsModalEndProcessParams, cairoTagsUnsuccessfulUpdateInServerParams as TagsUnsuccessfulUpdateInServerParams, cairoTryAgainClickedParams as TagsTryAgainClickedParams, cairoUndoClickedParams as TagsUndoClickedParams } from '@wix/bex-utils/@wix/bi-logger-os-data/v2/types';
import { Tag } from '@wix/bex-utils/@wix/ambassador-os-tags-v1-tag/types';
import { CollectionState } from '../CollectionState';
import { TypedEmitter } from '../../util';
import { ReportBI } from '../../services';
export interface TagsBIReporterParams {
    readonly collection: CollectionState<Tag>;
    readonly reportBi: ReportBI;
    readonly location: string;
}
export declare class TagsBIReporter {
    readonly collection: CollectionState<Tag, import("../..").FiltersMap>;
    readonly reportBi: ReportBI;
    readonly location: string;
    readonly events: TypedEmitter<{
        select: () => unknown;
        blur: () => unknown;
        add: () => unknown;
        clear: () => unknown;
    }>;
    private actionsMade;
    constructor(params: TagsBIReporterParams);
    set setActionsMade(actionName: string);
    resetActionsMade(): void;
    _clearAllEvents(): void;
    _getErrorType(e: any): "Technical issue" | "Network error";
    onSearch(searchValue: string): void;
    onAction(params: Partial<TagsAddDeleteTagParams>): void;
    onError(params: Partial<TagsUnsuccessfulUpdateInServerParams>, error: unknown): void;
    onTryAgain(params: Partial<TagsTryAgainClickedParams>): void;
    onUndo(params: Partial<TagsUndoClickedParams>): void;
    getActionsMadeChangesString(): string;
    onModalClose(params: Partial<TagsModalEndProcessParams>): void;
}
//# sourceMappingURL=TagsBIReporter.d.ts.map