import { TagsManagementState, TagsManagementStateParams } from './TagsManagementState';
import { TagsBIReporter } from './TagsBIReporter';
import { TagsFormState } from './TagsFormState';
import { Tags } from './tagsTypes';
import { TaskState } from '../TaskState';
import { WixPatternsContainer } from '../WixPatternsContainer';
export interface TagsWidgetStateParams extends TagsManagementStateParams {
    readonly origin: string;
}
export declare class TagsWidgetState {
    tagsFormState: TagsFormState | null;
    readonly tagsManagementState: TagsManagementState;
    readonly initTask: TaskState<unknown>;
    readonly tagsBIReporter: TagsBIReporter;
    readonly container: WixPatternsContainer;
    readonly origin: string;
    constructor({ container, origin, ...tagsManagementStateParams }: TagsWidgetStateParams);
    init(): () => void;
    retry: () => void;
    get isLoading(): boolean;
    get isError(): boolean;
    validate(): Promise<{
        isValid: boolean;
        tags?: Tags;
        values?: Tags;
    }>;
    get isDirty(): boolean;
}
//# sourceMappingURL=TagsWidgetState.d.ts.map