/// <reference types="jest" />
/// <reference types="chance" />
import { WixPatternsContainerDriver, WixPatternsContainerDriverOverrides } from './WixPatternsContainer.driver';
import { CollectionState, CollectionStateParams } from '../state';
import { InMemoryBackend, InMemoryBackendParams } from '../InMemoryBackend';
import { Product } from './product';
import { ProductFilters } from './productFilters';
export interface ProductsCollectionStateDriverOverrides extends WixPatternsContainerDriverOverrides {
    readonly collection?: Partial<CollectionStateParams<Product, ProductFilters>>;
    readonly backend?: Partial<InMemoryBackendParams<Product, ProductFilters>>;
}
export declare class ProductsCollectionStateDriver {
    readonly container: WixPatternsContainerDriver;
    readonly backend: InMemoryBackend<Product, ProductFilters>;
    readonly overrides: ProductsCollectionStateDriverOverrides;
    collection: CollectionState<Product, ProductFilters>;
    constructor(overrides?: ProductsCollectionStateDriverOverrides);
    reCreateCollection(): void;
    getRandomItem(): {
        index: number;
        item: Product;
    };
    fetchDataStartSpy: () => jest.Mock<any, any>;
    get items(): Product[];
    get chance(): Chance.Chance;
}
//# sourceMappingURL=ProductsCollectionState.driver.d.ts.map