import { ShowToast as CairoShowToast, ToastAction as CairoToastAction, ToastConfig as CairoToastConfig } from '../model/toast';
type CairoToastConfigRequired = Required<CairoToastConfig>;
type ToastActionRequired = Required<CairoToastAction>;
export declare const toastConfigMaps: {
    priority: Record<CairoToastConfigRequired['priority'], ToastConfig['priority']>;
    timeout: Record<CairoToastConfigRequired['timeout'], ToastConfig['timeout']>;
    type: Record<CairoToastConfigRequired['type'], ToastConfig['type']>;
    uiType: Record<ToastActionRequired['uiType'], ToastAction['uiType']>;
};
export declare function showToastCompat(showToast: ShowToast): CairoShowToast;
type ToastTimeout = 'normal' | 'none';
type ToastType = 'standard' | 'success' | 'warning' | 'error';
type ToastPriority = 'low' | 'normal' | 'high';
type ToastActionUiType = 'button' | 'link';
type ToastAction = {
    text: string;
    uiType?: ToastActionUiType;
    removeToastOnClick?: boolean;
    onClick: () => void;
};
type ToastConfig = {
    message: string;
    timeout?: ToastTimeout;
    type?: ToastType;
    priority?: ToastPriority;
    action?: ToastAction;
    onCloseClick?: () => void;
    onToastSeen?: () => void;
};
type ShowToast = (config: ToastConfig) => {
    remove: () => void;
} | Promise<{
    remove: () => void;
}>;
export {};
//# sourceMappingURL=showToastCompat.d.ts.map